"use strict";
///<reference path="../lib.deno.d.ts" />
Object.defineProperty(exports, "__esModule", { value: true });
exports.open = void 0;
const fs_1 = require("fs");
const util_1 = require("util");
const File_js_1 = require("../classes/File.js");
const fs_flags_js_1 = require("../../internal/fs_flags.js");
const nodeOpen = (0, util_1.promisify)(fs_1.open);
const open = async function open(path, { read, write, append, truncate, create, createNew, mode = 0o666 } = {
    read: true,
}) {
    const flagMode = (0, fs_flags_js_1.getFsFlag)({
        read,
        write,
        append,
        truncate,
        create,
        createNew,
    });
    const fd = await nodeOpen(path, flagMode, mode);
    return new File_js_1.File(fd);
};
exports.open = open;
